package org.fouram.service;

import org.fouram.core.base.service.BaseService;
import org.fouram.enums.DelFlagEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class SyncSapUserToWxService extends BaseService {

	@Autowired
	private WxUserService wxUserService;
	@Autowired
	private SapUserService sapUserService;
	@Autowired
	private WxDepartService wxDepartService;
	
	@Transactional
	public void taskBiz() throws Exception {
		// 更新微信部门
		wxDepartService.saveWxDeparts();
		// 更新微信用户
		wxUserService.saveWxUsers();
		// 更新所有数据无效
		sapUserService.updateAllDelFlag(DelFlagEnum.UNABLE.getCode());
		// 保存SAP用户数据-数据没变化的result状态保持不变
		sapUserService.saveOrUpdateSapUsers();
		// 更新异常情况，敏感数据、入职
		sapUserService.updateAbnormalResult();
		// 更新用户头像
		sapUserService.updateAvatars();

		// 部分数据插入微信未成功，处理数据后，重新插入
//		List<SapUser> unSyncSapUsers = sapUserService.selectUnSyncList();
//		LoggerUtil.info("部分未成功插入数据->" + unSyncSapUsers.size());
//		for (SapUser sapUser : unSyncSapUsers) {
//			sapUserService.updateSyncWxResult(sapUser.getPersonId());
//		}
//		LoggerUtil.info("同步结束->" + DateUtil.getTime());
	}

	// 发送禁用企业微信账号信息
//	private void sendQuitUserMsg() throws Exception {
//		List<SapUser> unableSapUsers = sapUserService.selectListByDelFlag(DelFlagEnum.UNABLE.getCode());
//		if (unableSapUsers.size() > 0) {
//			WXCpMessageUtil.sendQuitUserMsg("离职用户" + unableSapUsers.size() + "个，请确认");
//		}
//	}
}
